// CamImage.h

#ifndef My__CamImage
#define My__CamImage


// Dependencies
#include "Aria.h"


// CamImage class
// Holds an image, with reference count for thread safety
class CamImage {
	public:
		CamImage(int imageId, char *data, int len);
		~CamImage();
		
		CamImage* acquire();
		void release();
		
		bool decodeImage();
		bool makeBmp();
	
	private:
		int				m_usage;
		
		ArMutex			m_mutex;
		
		bool			m_decoded;
		bool			m_decoding;
		
		bool			m_hasBmp;
		bool			m_makingBmp;
	
	// Image data is public because it's used by image processing etc.
	public:
		int				id;
		
		unsigned char	*imageData;
		int				dataLen;
		
		unsigned char	*pixels;
		int				w;
		int				h;
		
		char			*bmp;
		int				bmpLen;
};


#endif
