#ifndef My__HTTPConnection
#define My__HTTPConnection


#include "Aria.h"
#include <vector>

class ProbabilityMap;
class RobotHandler;
class ImageProvider;


// HTTP connection handler
class HTTPConnection {
	public:
		HTTPConnection(
			ProbabilityMap *map,
			RobotHandler *robotHandler,
			ImageProvider *imgProvider
		);
		~HTTPConnection();
		
		bool handleConnection(ArSocket *sock);
		void closeNow();
		
		void handleNetwork();
		
		bool handleRead();
		
		int parseGet(const char *data, int len);
		int parseHeader(const char *data, int len);
		int parseLine(const char *data, int len);
		void sendFile();
		void parseMoveto(const char *str, int len);
		void parseOrders(const char *str, int len);
		void parseCam(const char *str, int len);
		void parseSonar(const char *str, int len);
	
	private:
		ProbabilityMap			*m_map;
		RobotHandler			*m_robotHandler;
		ImageProvider			*m_imgProvider;
		
		ArMutex					m_mutex;
		
		bool					m_exit;
		bool					m_hasSock;
		ArSocket				*m_sock;
		std::vector<ArSocket*>	m_sockQueue;
		
		int						m_maxBytes;
		char					*m_data;
		int						m_nBytes;
		
		char					*m_mapData;
		
		std::string				m_requestFile;
};


#endif
