#ifndef My__HTTPServer
#define My__HTTPServer


#include "Aria.h"
#include <vector>

class HTTPConnection;
class ProbabilityMap;
class RobotHandler;
class ImageProvider;


// HTTP server
class HTTPServer : public ArASyncTask {
	public:
		HTTPServer(
			ProbabilityMap *map,
			RobotHandler *robotHandler,
			ImageProvider *imgProvider,
			HTTPConnection *connectionHandler
		);
		
		void* runThread(void*);
		
		void myStop();
	
	private:
		ArSocket						m_sock;
		ProbabilityMap					*m_map;
		RobotHandler					*m_robotHandler;
		ImageProvider					*m_imgProvider;
		HTTPConnection					*m_connectionHandler;
};


#endif

