// ImageProvider.h

#ifndef My__ImageProvider
#define My__ImageProvider


// Dependencies

#include "Aria.h"

class CamImage;



// ImageProvider class

class ImageProvider : public ArASyncTask {
	public:
		ImageProvider();
		~ImageProvider();
		
		void* runThread(void*);
		
		void myStop();
		
		bool handleData(char *data, int len);
		int parseContentLength(const char *data, int len);
		int findContentLength(const char *data, int len);
		
		CamImage* getImage();
	
	private:
		ArSocket	m_sock;
		ArMutex		m_mutex;
		CamImage	*m_curImage;
		
		int			m_nextImageId;
		
		char		*m_data;
		int			m_dataLen;
		
		int			m_state;
		int			m_contentLength;
};


#endif
